# frozen_string_literal: true

require 'pathname'
require_relative 'tree/scanner'
require_relative 'tree/tree_render'

# Tree class create array of all root directories
class Tree
  attr_reader :root,
              :directories,
              :files,
              :tree_data,
              :path_array

  def initialize(path = Dir.pwd)
    @root = path
    @directories = 0
    @files = 0
    @tree_data = []
    @path_array = []
  end

  def run
    @root = Pathname.new(@root)
    @root.each_child do |dir|
      @path_array << dir
      @tree_data << dir
    end
  end

  def run_results
    [@path_array, @directories, @files, @tree_data, @root]
  end
end
